import React, { useState, useEffect } from 'react';
import { sum, csv, format, timeParse } from 'd3';

const csvUrl = "https://raw.githubusercontent.com/CSSEGISandData/COVID-19/master/csse_covid_19_data/csse_covid_19_time_series/time_series_covid19_deaths_global.csv";

export const useData = () => {
  const [data, setData] = useState();
  
  const sum = (accumulator, currentValue) => accumulator + currentValue;
  
  const parseDate = timeParse('%m/%d/%y');
  
  const transform = (rawData) => {
  	const dates = rawData.columns.slice(4);
    return dates.map(date => (
      {
        date: parseDate(date),
        deathTotal: rawData.map(d => +d[date]).reduce(sum, 0)
      }
   	));
  };
  
  useEffect(() => {
    csv(csvUrl).then(rawData => {
      setData(transform(rawData));
    });
  }, []);
  
  return data;
};